#define GL_GLEXT_PROTOTYPES 1

#include <GL/glut.h>
#include <math.h>

#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>

#include "bludi.h"

char demo = 0;
char invert = 0;
static float plynulost = 10;
static char debugrot = 0;
static char dohlednu = 10;
static int X=0, Y=0, Z=0;
static float fX=0, fY=0, fZ=0;
static double speed = 0.8, rspeed = 1.2;
static int lX=0,lY=1,lZ=0;
static double flX=0,flY=1,flZ=0;
static int kX=0,kY=0,kZ=1;
static double fkX=0,fkY=0,fkZ=1;
static int timerInterval=200;              // interval casovace v milisekundach
static int width, height;
static int sc_width, sc_height;
static char mezera;
static char zmena=1;
static GLfloat fogcolor[4] = {0.0, 0.0, 0.0, 1.0};

void popojdi();
void demojdi();

void drawstr(float x, float y, char* format, ...)
{
    va_list args;
    char buffer[255], *s;
    
    va_start(args, format);
    vsprintf(buffer, format, args);
    va_end(args);
    
    //glWindowPos2i(x, y);
    for (s = buffer; *s; s++)
      glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_24, *s);
}

void pootocse()
{
  double uX,uY,uZ, vX,vY,vZ, wX,wY,wZ,tX,tY,tZ, w;
  double c,c1,s, uhel, d1, d2;
  double nepresnost =0.0001;
  char  merl;

  if(lX == flX && lY == flY && lZ == flZ && kX == fkX && kY == fkY && kZ == fkZ) return;

  zmena = 1;

  if(debugrot){
    printf("\nStart\n\n");
    printf("\n");
    printf("(%f, %f, %f), (%f, %f, %f) ==> (%d, %d, %d), (%d, %d, %d)",
	   flX,flY,flZ,fkX,fkY,fkZ,lX,lY,lZ,kX,kY,kZ);
  }

  if(fabs(lX-flX) <= nepresnost &&
     fabs(lY-flY) <= nepresnost &&
     fabs(lZ-flZ) <= nepresnost &&
     fabs(kX-fkX) <= nepresnost &&
     fabs(kY-fkY) <= nepresnost &&
     fabs(kZ-fkZ) <= nepresnost){
    if(debugrot) printf("zaokrouhluji\n");
    flX=lX;
    flY=lY;
    flZ=lZ;
    fkX=kX;
    fkY=kY;
    fkZ=kZ;
    return;
  }

  uX = flX-lX; uY = flY-lY; uZ = flZ-lZ;
  vX = fkX-kX; vY = fkY-kY; vZ = fkZ-kZ;  
  if(debugrot) printf("w = (%f, %f, %f)x(%f, %f, %f)\n",
		      uX, uY, uZ, vX, vY, vZ);
  wX = uY*vZ-uZ*vY; wY = uZ*vX-uX*vZ;  wZ = uX*vY-uY*vX;
  w = sqrt(wX*wX+wY*wY+wZ*wZ);
  if(w <= nepresnost){
    if(debugrot) printf("VYJIMKA 1\n");
    uX = flY*fkZ-flZ*fkY; uY = flZ*fkX-flX*fkZ;  uZ = flX*fkY-flY*fkX;
    vX = lY*kZ-lZ*kY; vY = lZ*kX-lX*kZ;  vZ = lX*kY-lY*kX;
    if(debugrot) printf("w = (%f, %f, %f)x(%f, %f, %f)\n", uX, uY, uZ,
			vX, vY, vZ);
    wX = uY*vZ-uZ*vY; wY = uZ*vX-uX*vZ;  wZ = uX*vY-uY*vX;
    w = sqrt(wX*wX+wY*wY+wZ*wZ);
    if(w <= nepresnost){
      if(lX*flX + lY*flY + lZ*flZ < kX*fkX + kY*fkY + kZ*fkZ){
	if(debugrot) printf("VYJIMKA 2.1: %f < %f\n",
			    lX*flX + lY*flY + lZ*flZ, kX*fkX + kY*fkY + kZ*fkZ);
	wX = flX+lX; wY = flY+lY; wZ = flZ+lZ; 
      }
      else{
	if(debugrot) printf("VYJIMKA 2.2: %f >= %f\n",
			    lX*flX + lY*flY + lZ*flZ, kX*fkX + kY*fkY + kZ*fkZ);
	wX = fkX+kX; wY = fkY+kY; wZ = fkZ+kZ;
      }
      w = sqrt(wX*wX+wY*wY+wZ*wZ);
    }
  }
  if(w <= nepresnost){
    warning("nenasel jsem osu otaceni: (%f,%f,%f),(%f,%f,%f) ===> (%d,%d,%d),(%d,%d,%d)",
	    flX,flY,flZ, fkX,fkY,fkZ, lX,lY,lZ, kX,kY,kZ);
    flX = lX; flY = lY; flZ = lZ;
    fkX = kX; fkY=kY;  fkZ = kZ;
    return;
  }

  if(debugrot) printf("\nw = (%f, %f, %f)\n", wX, wY, wZ);
  wX /= w;
  wY /= w;
  wZ /= w;
  if(debugrot) printf("normalizuji w: (%f, %f, %f)\n\n", wX, wY, wZ);

  if(debugrot) printf("(%f, %f, %f)\n", wX, wY, wZ);

  
  if(fabs(wX*lX+wY*lY+wZ*lZ) <= fabs(wX*kX+wY*kY+wZ*kZ)) merl = 1;
  else merl = 0;

  if(merl) d1 = wX*lY*flZ+wY*lZ*flX+wZ*lX*flY-wX*lZ*flY-wY*lX*flZ-wZ*lY*flX;
  else d1 = wX*kY*fkZ+wY*kZ*fkX+wZ*kX*fkY-wX*kZ*fkY-wY*kX*fkZ-wZ*kY*fkX;

  if(d1>0) uhel = -rspeed/plynulost;
  else uhel = rspeed/plynulost;

  c = cos(uhel);
  c1 = 1-c;
  s = sin(uhel);

  uX = flX*(wX*wX*c1+c)    + flY*(wX*wY*c1-wZ*s) + flZ*(wX*wZ*c1+wY*s);
  uY = flX*(wX*wY*c1+wZ*s) + flY*(wY*wY*c1+c)    + flZ*(wY*wZ*c1-wX*s);
  uZ = flX*(wX*wZ*c1-wY*s) + flY*(wY*wZ*c1+wX*s) + flZ*(wZ*wZ*c1+c);

  vX = fkX*(wX*wX*c1+c)    + fkY*(wX*wY*c1-wZ*s) + fkZ*(wX*wZ*c1+wY*s);
  vY = fkX*(wX*wY*c1+wZ*s) + fkY*(wY*wY*c1+c)    + fkZ*(wY*wZ*c1-wX*s);
  vZ = fkX*(wX*wZ*c1-wY*s) + fkY*(wY*wZ*c1+wX*s) + fkZ*(wZ*wZ*c1+c);

  w = sqrt(uX*uX+uY*uY+uZ*uZ);
  if(!w){
    warning("U je nulovy vektor");
    uX = lX; uY = lY; uZ = lZ;
  }
  else if(w != 1){
    if(debugrot) printf("normalizuji: %f\n", w);
    uX/=w; uY/=w; uZ/=w;
  }

  if(uX*vX+uY*vY+uZ*vZ != 0){
    if(debugrot) printf("kolmim: U*V = %f, (%f, %f, %f)\n", uX*vX+uY*vY+uZ*vZ, vX,vY,vZ);
    tX = uY*vZ-uZ*vY; tY = uZ*vX-uX*vZ; tZ = uX*vY-uY*vX;
    vX = tY*uZ-tZ*uY; vY = tZ*uX-tX*uZ; vZ = tX*uY-tY*uX;
    if(debugrot) printf("zkolmil jsem: U*V = %f, (%f, %f, %f)\n",
      uX*vX+uY*vY+uZ*vZ, vX,vY,vZ);
  }

  w = sqrt(vX*vX+vY*vY+vZ*vZ);
  if(!w){
    warning("V je nulovy vektor");
    vX = kX; vY = kY; vZ = kZ;
  }
  else if(w != 1){
    if(debugrot) printf("normalizuji: %f\n", w);
    vX/=w; vY/=w; vZ/=w;
  }

  if(d1){
    if(merl) d2 = wX*lY*uZ+wY*lZ*uX+wZ*lX*uY-wX*lZ*uY-wY*lX*uZ-wZ*lY*uX;
    else d2 = wX*kY*vZ+wY*kZ*vX+wZ*kX*vY-wX*kZ*vY-wY*kX*vZ-wZ*kY*vX;
    if(debugrot) printf("d1=%f, d2=%f\n", d1, d2);
    if((d1 < 0 && d2 > 0) || (d1 > 0 && d2 < 0)){
      if(debugrot){
	printf("pretocil jsem, koncim\n");
	printf("fl = (%f, %f, %f)\n", flX, flY, flZ);
	printf("l = (%d, %d, %d)\n", lX, lY, lZ);
	printf("kl = (%f, %f, %f)\n", fkX, fkY, fkZ);
	printf("k = (%d, %d, %d)\n", kX, kY, kZ);
	if(merl) printf("sleduji L\n");
	else printf("sleduji K\n");
	printf("u = (%f, %f, %f)\n", uX, uY, uZ);
	printf("v = (%f, %f, %f)\n", vX, vY, vZ);
      }
      flX = lX; flY=lY;  flZ = lZ;
      fkX = kX; fkY=kY;  fkZ = kZ;
      return;
    }
  }

  flX=uX; flY=uY; flZ=uZ;
  fkX=vX; fkY=vY; fkZ=vZ;
}

void onTimer(int value)
{
  float *fxyz = NULL;

  glutTimerFunc(timerInterval/plynulost, onTimer, value); // znovu pustit casovac

  if(fX) fxyz = &fX;
  if(fY) fxyz = &fY;
  if(fZ) fxyz = &fZ;
  if(fxyz){
    if(fabsf(*fxyz) < speed/plynulost) *fxyz = 0;
    else *fxyz -= speed/plynulost*(*fxyz/fabsf(*fxyz));
    zmena = 1;
  }

  if(demo) demojdi();
  if(mezera) popojdi();

  pootocse();
  if(zmena) glutPostRedisplay();            // prekreslit scenu
}

void loadlook()
{
  glLoadIdentity();
  gluLookAt(fX+X, fY+Y, fZ+Z, 
	    fX+X+flX, fY+Y+flY, fZ+Z+flZ,
	    fkX, fkY, fkZ);
}


void changeSize(int w, int h)
{
  width = w;
  height = h;

  // Prevent a divide by zero, when window is too short
  // (you cant make a window of zero width).
  if(h == 0) h = 1;
  if(w == 0) w = 1;

  // Reset the coordinate system before modifying
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
	
  // Set the viewport to be the entire window
  glViewport(0, 0, w, h);

  // Set the clipping volume
  glScalef(sqrt((float)h/w)/4, sqrt((float)w/h)/4, 1);
  gluPerspective(45,1,0.001,dohlednu);
  glMatrixMode(GL_MODELVIEW);
}

void initScene()
{
  glEnable(GL_DEPTH_TEST);
  glEnable(GL_BLEND);
  glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
  glEnable(GL_FOG);
  glFogfv(GL_FOG_COLOR, fogcolor);
  glFogf(GL_FOG_DENSITY, 0.5);
  glFogi(GL_FOG_MODE, GL_EXP);
}

static float predbarva[2];

void kreslictverec(float barva, float *abarva, int x, int y, int z, char smer)
{
  int *zed, i;

  zed = zed_sour(x,y,z,smer);
  if(zed != &zdi_SC[0] && zed != &zdi_SC[1] && zed && !*zed) return;

  glColor3f(barva, barva, barva);
  for(i=0; i<2; i++){
    if(zed == &zdi_SC[i]){
      if(abarva[i] != 1) return;
      predbarva[i] = barva;
      glColor3f(0, barva*i, barva*(1-i));
    }
  }

  glRectf(-0.5, -0.5, 0.5, 0.5);
}

char aktusmer(int x, int y, int z)
{
  if(x) return (1-x)/2;
  if(y) return (1-y)/2+2;
  if(z) return (1-z)/2+4;

  warning("nepovedlo se urcit smer");
  return -1;
}

void renderScene(void)
{
  int x, y, z, dx, dy, dz, i;
  int startx, starty, startz, endx, endy, endz;
  float barva, abarva[2];

  abarva[0] = abarva[1] = 1;
  if(fX || fY || fZ){
    dx=dy=dz=0;
    if(fX) dx = fX/fabs(fX);
    if(fY) dy = fY/fabs(fY);
    if(fZ) dz = fZ/fabs(fZ);
    x = X-1; y = Y-1; z = Z-1;
    for(i=0; i<2; i++)
      if((x == SCX[i] && y == SCY[i] && z == SCZ[i] &&
	  SCstena[i] == opacsmer(aktusmer(dx,dy,dz))) ||
	 (x+dx == SCX[i] && y+dy == SCY[i] && z+dz == SCZ[i] &&
	  SCstena[i] == aktusmer(dx,dy,dz)))
	abarva[i] = fabs(fabs(fX+fY+fZ)-0.5);
  }

  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  /*
  glColor3f(1, 1, 1);
  drawstr(30, 30, "ahoj svete");
  */

  loadlook();

  startx = X-1-dohlednu;
  starty = Y-1-dohlednu;
  startz = Z-1-dohlednu;
  if(startx < 0) startx = 0;
  if(starty < 0) starty = 0;
  if(startz < 0) startz = 0;
  endx = X-1+dohlednu;
  endy = Y-1+dohlednu;
  endz = Z-1+dohlednu;
  if(endx > sirka) endx = sirka;
  if(endy > vyska) endy = vyska;
  if(endz > hloubka) endz = hloubka;

  if(startx > endx || starty > endy || startz > endz) return;

  glPushMatrix();
  if(startx || starty || startz) glTranslatef(startx, starty, startz);

  barva = fabs(flZ)-fabs(fkZ);
  barva /= 10;
  barva += 0.7;

  glPushMatrix();
  glTranslatef(1, 1, 0.5);
  for(z=startz; z<=endz; z++){
    glPushMatrix();
    for(y=starty; y<endy; y++){
      glPushMatrix();
      for(x=startx; x<endx; x++){
	kreslictverec(barva,abarva,x,y,z,DOZADU);
	glTranslatef(1, 0, 0);
      }
      glPopMatrix();
      glTranslatef(0, 1, 0);
    }
    glPopMatrix();
    glTranslatef(0, 0, 1);
  }
  glPopMatrix();

  barva = fabs(flY)-fabs(fkY);
  barva /= 10;
  barva += 0.7;
  glPushMatrix();
  glRotatef(90, 1,0,0);
  glTranslatef(1, 1, -0.5);
  for(y=starty; y<=endy; y++){
    glPushMatrix();
    for(z=startz; z<endz; z++){
      glPushMatrix();
      for(x=startx; x<endx; x++){
	kreslictverec(barva,abarva,x,y,z,NAHORU);
	glTranslatef(1, 0, 0);
      }
      glPopMatrix();
      glTranslatef(0, 1, 0);
    }
    glPopMatrix();
    glTranslatef(0, 0, -1);
  }
  glPopMatrix();

  barva = fabs(flX)-fabs(fkX);
  barva /= 10;
  barva += 0.7;
  glPushMatrix();
  glRotatef(-90, 0,1,0);
  glTranslatef(1, 1, -0.5);
  for(x=startx; x<=endx; x++){
    glPushMatrix();
    for(y=starty; y<endy; y++){
      glPushMatrix();
      for(z=startz; z<endz; z++){
	kreslictverec(barva,abarva,x,y,z,VLEVO);
	glTranslatef(1, 0, 0);
      }
      glPopMatrix();
      glTranslatef(0, 1, 0);
    }
    glPopMatrix();
    glTranslatef(0, 0, -1);
  }
  glPopMatrix();
  glPopMatrix();

  for(i=0; i<2; i++){
    if(abarva[i] != 1){
      glPushMatrix();
      glTranslatef(X,Y,Z);
      glColor4f(0, predbarva[i]*i, predbarva[i]*(1-i), abarva[i]);
      if(fZ){
	if(fZ > 0) glTranslatef(0,0,0.5);
	else glTranslatef(0,0,-0.5);
      }
      else{
	glRotatef(90, -fY,fX,0);
	glTranslatef(0,0,0.5);
      }
      glRectf(-0.5, -0.5, 0.5, 0.5);
      glPopMatrix();
    }
  }

  glutSwapBuffers();
  zmena = 0;
}

void demorient()
{
  int lx, ly, lz, smer;

  smer = demotah(X-1, Y-1, Z-1);
  if(smer < 0){
    demo = 0;
    return;
  }

  lx = ly = lz = 0;
  posunsour(&lx, &ly, &lz, smer);

  if(lx*kX + ly*kY + lz*kZ){
    if(lx == kX && ly == kY && lz == kZ){
      kX = -lX; kY = -lY; kZ = -lZ;
    }
    else{
      kX = lX; kY = lY; kZ = lZ;
    }
  }
  lX = lx; lY = ly; lZ = lz;
}

void demojdi()
{
  if(fX || fY || fZ) return;

  if(demo == 2){
    demorient();
    if(demo) demo = 1;
  }

  X += lX;
  fX =-lX;
  Y += lY;
  fY =-lY;
  Z += lZ;
  fZ =-lZ;

  demorient();
}

void orientMe(char lr, char opacne)
{
  int px, py, pz;

  if(demo) return;

  if(invert && !lr) opacne = !opacne;

  px = lX;
  py = lY;
  pz = lZ;

  if(lr){
    lX = py*kZ-pz*kY;
    lY = pz*kX-px*kZ;
    lZ = px*kY-py*kX;
  }
  else{
    lX = kX; lY = kY; lZ = kZ;
    if(opacne){ kX = px; kY = py; kZ = pz; }
    else      { kX =-px; kY =-py; kZ =-pz; }

  }
  if(opacne){ lX *=-1; lY*= -1; lZ *= -1; }
}

void popojdi()
{
  if(demo) return;

  if(fX || fY || fZ) return;
  if(!analyzujtah(X-1, Y-1, Z-1, aktusmer(lX,lY,lZ))) return;

  X += lX;
  fX =-lX;
  Y += lY;
  fY =-lY;
  Z += lZ;
  fZ =-lZ;
}

int fwidth, fheight, fullX, fullY;

void processNormalKeys(unsigned char key, int x, int y)
{
  key=(key>'A' && key<='Z') ? key+'a'-'A':key; // prevod na mala pismena

  switch(key){
  case 27: exit(0);
  case 'i': invert = !invert; break;
  case 'f':
    if(width == sc_width && height == sc_height){
      glutPositionWindow(fullX, fullY);
      glutReshapeWindow(fwidth, fheight);
      glutPostRedisplay();
    }
    else{
      fullX = glutGet(GLUT_WINDOW_X);
      fullY = glutGet(GLUT_WINDOW_Y);
      fwidth = width;
      fheight = height;
      glutFullScreen();
      glutPositionWindow(0, 0);
    }
    break;
  case ' ': popojdi(); mezera = 1; break;
  }
}

void releaseKey(unsigned char key, int x, int y)
{
  if(key == ' ') mezera = 0;
}

void inputKey(int key, int x, int y)
{
  switch (key) {
  case GLUT_KEY_LEFT:  orientMe(1,1);break;
  case GLUT_KEY_RIGHT: orientMe(1,0);break;
  case GLUT_KEY_UP:    orientMe(0,0); break;
  case GLUT_KEY_DOWN:  orientMe(0,1); break;
  }
}


int main(int argc, char **argv)
{
  char fstart;

  fstart = 0;
  nastavbludi(argc, argv, &fstart);
  vytvorbludi();
  analyzujbludi();

  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_DEPTH | GLUT_DOUBLE | GLUT_RGBA);
  glutInitWindowSize(640,480);
  glutCreateWindow("Labyrint 3D");

  initScene();

  glutKeyboardFunc(processNormalKeys);
  glutKeyboardUpFunc(releaseKey);
  glutSpecialFunc(inputKey);

  glutDisplayFunc(renderScene);
  glutTimerFunc(timerInterval/plynulost, onTimer, 1234);
  glutReshapeFunc(changeSize);

  if(fstart){
    fullX = 50;
    fullY = 50;
    fwidth = 640;
    fheight = 480;
    glutFullScreen();
    glutPositionWindow(0, 0);
  }

  sc_width = glutGet(GLUT_SCREEN_WIDTH);
  sc_height = glutGet(GLUT_SCREEN_HEIGHT);

  glutMainLoop();

  return(0);
}
